/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */

package bandit;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Flow.Subscriber;
import java.util.concurrent.SubmissionPublisher;
import java.util.concurrent.atomic.AtomicBoolean;
import java.util.logging.Logger;
import bandit.util.OhmLogger;

/**
 *
 * @author le
 */
public class Zahlengenerator implements Runnable // Callable
{
  private static Logger lg = OhmLogger.getLogger(); //Logger sollten immer static sein da sie für alle instanzen loggs ausführen
  
  private int wert;
  /** Zustandsvariable !!! 
   *  bei 2 Werten boolean sonst enum 
   */
//  private volatile boolean laufend;
  private AtomicBoolean laufend;
  //private Thread thd;
  private ExecutorService eService;
  
  private final Object LOCK;
  
  private SubmissionPublisher<Integer> wertPublisher;
  
  public Zahlengenerator()
  {
    wert = -1;
    //laufend = false;
    laufend = new AtomicBoolean(false);
    //thd = null;
    eService = Executors.newSingleThreadExecutor();
    wertPublisher = new SubmissionPublisher<>();
    LOCK = new Object();
  }
  
  public void addWertSubscription(Subscriber<Integer> subscriber)
  {
    wertPublisher.subscribe(subscriber);
  }
  
  public void start()
  {
    //laufend = true;
    laufend.set(true);
    synchronized (LOCK)
    {
      LOCK.notify();
    }
    
    
    if (eService.isShutdown())
    {
      eService = Executors.newSingleThreadExecutor();
    }
    eService.execute(this);
    //Future task = eService.submit(this); v.a. bei callable
//    if (thd == null)
//    {
//      thd = new Thread(this);
//      thd.start();
//    }
  }
  
  public void stop()
  {
    //laufend = false;
    laufend.set(false);
  }

  @Override
  public void run()
  {
    while (true)
    {
      //while (!laufend)
      while (!laufend.get())
      {
        synchronized (LOCK)
        {
          try
          {
            lg.info("WAIT");
            LOCK.wait();
          }
          catch (InterruptedException ex)
          {
            lg.warning(ex.toString());
          }
        }
      }
         
      try
      {
        Thread.sleep(100);
      }
      catch (Exception ex)
      {
        System.err.println(ex);
      }
      this.berechneWert();
      wertPublisher.submit(wert);
    }
//    thd = null;
//    eService.shutdown();
  }

  private synchronized void berechneWert()
  {
    wert = (int) (1 + 49*Math.random());
  }
  
  public synchronized int getWert()
  {
    return wert;
  }
  
}
